Index: tmp/org.txm.cooccurrence.core/src/org/txm/cooccurrence/core/functions/Cooccurrence.java
===================================================================
--- tmp/org.txm.cooccurrence.core/src/org/txm/cooccurrence/core/functions/Cooccurrence.java	(revision 2947)
+++ tmp/org.txm.cooccurrence.core/src/org/txm/cooccurrence/core/functions/Cooccurrence.java	(revision 2948)
@@ -1518,37 +1518,43 @@
 	 * @return the query
 	 */
 	public String createQuery(List<CLine> lines) {
-		
+
 		if (this.getQuery().isEmpty()) {
 			return ""; //$NON-NLS-1$
 		}
-		
-		
+
+
 		int nbProps = this.getProperties().size();
 		List<WordProperty> props = this.getProperties();
-		
-		String query = "["; //$NON-NLS-1$
+
+		String query = "@["; //$NON-NLS-1$
 		for (int p = 0; p < nbProps; p++) {
-			query += props.get(p) + "=\""; //$NON-NLS-1$
-			for (int l = 0; l < lines.size(); l++) {
-				CLine line = lines.get(l);
-				String s = line.props.get(p);
-				s = CQLQuery.addBackSlash(s);
-				query += s + "|"; //$NON-NLS-1$
+
+			if (props.get(p) instanceof WordProperty) {
+				ArrayList<String> values = new ArrayList<String>();
+				for (int l = 0; l < lines.size(); l++) {
+					CLine line = lines.get(l);
+					String s = line.props.get(p);
+					values.add(s);
+				}
+				String test = ((WordProperty)props.get(p)).getCQLTest(values);
+				if (test != null) {
+					query += test;
+				}
 			}
-			query = query.substring(0, query.length() - 1);
-			query += "\" & "; //$NON-NLS-1$
+			if (p < nbProps-1) {
+				query += " & "; //$NON-NLS-1$
+			}
 		}
-		query = query.substring(0, query.length() - 3);
 		query += "] "; //$NON-NLS-1$
-		
+
 		int maxempan = Math.max(this.getMaxLeft(), this.getMaxRight());
 		if (this.getIncludeXPivot() && maxempan == 0) maxempan = 1;
-		
+
 		String maxempanstr = "within " + maxempan + " "; //$NON-NLS-1$ //$NON-NLS-2$
 		if (this.getStructuralUnitLimit() != null) maxempanstr += this.getStructuralUnitLimit().getName();
-		
-		
+
+
 		String pquery = CQLQuery.fixQuery(this.getQuery().getQueryString());
 		if (this.getMaxLeft() == 0) {
 			query = "" + pquery + " []* " + query + " " + maxempanstr; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
@@ -1559,43 +1565,43 @@
 		else {
 			query = "(" + pquery + " []* " + query + ") | (" + query + " []* " + pquery + ") " + maxempanstr; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
 		}
-		
+
 		return query;
 	}
-	
-	
+
+
 	/**
 	 * The Class CLine.
 	 */
 	public class CLine {
-		
+
 		/** The cooc. */
 		Cooccurrence cooc;
-		
+
 		/** The distmoyenne. */
 		public float distmoyenne;
-		
+
 		/** The freq. */
 		public int freq;
-		
+
 		/** The id. */
 		public int id;
-		
+
 		/** The mode. */
 		public long mode;
-		
+
 		/** The nbocc. */
 		public int nbocc;
-		
+
 		/** The occ. */
 		public String occ;
-		
+
 		/** The props. */
 		public List<String> props;
-		
+
 		/** The score. */
 		public double score;
-		
+
 		/**
 		 * Instantiates a new c line.
 		 *
@@ -1619,7 +1625,7 @@
 			this.mode = mode;
 			this.cooc = cooc;
 		}
-		
+
 		/**
 		 * Adds the txt sep.
 		 *
@@ -1630,7 +1636,7 @@
 		private String addTxtSep(String str, String sep) {
 			return sep + str.replace(sep, sep + sep) + sep;
 		}
-		
+
 		/**
 		 * Gets the cooc.
 		 *
@@ -1639,7 +1645,7 @@
 		public Cooccurrence getCooc() {
 			return cooc;
 		}
-		
+
 		/**
 		 * Resume.
 		 *
@@ -1651,7 +1657,7 @@
 			return addTxtSep("" + occ, txtseparator) //$NON-NLS-1$
 					+ colseparator + freq + colseparator + nbocc + colseparator + score + colseparator + distmoyenne;
 		}
-		
+
 		/**
 		 * Sets the count and dist.
 		 *
@@ -1662,7 +1668,7 @@
 			this.nbocc = count;
 			this.distmoyenne = dist;
 		}
-		
+
 		/**
 		 * Sets the freq.
 		 *
@@ -1671,26 +1677,26 @@
 		public void setFreq(int freq) {
 			this.freq = freq;
 		}
-		
+
 		/**
 		 * Sets the score.
 		 */
 		public void setScore() {// FB == freq, R = nbocc
 			this.score = (this.nbocc + this.freq + this.distmoyenne);
 		}
-		
+
 		@Override
 		public String toString() {
 			return occ + CooccurrenceCoreMessages.fColon + freq + CooccurrenceCoreMessages.occColon + nbocc + CooccurrenceCoreMessages.scoreColon + score + CooccurrenceCoreMessages.meanDistColon
 					+ distmoyenne + CooccurrenceCoreMessages.propertiesColon + props;
 		}
 	}
-	
-	
+
+
 	@Override
 	public String getResultType() {
 		return CooccurrenceCoreMessages.RESULT_TYPE;
 	}
-	
-	
+
+
 }
Index: tmp/org.txm.index.rcp/src/org/txm/index/rcp/editors/PartitionIndexEditor.java
===================================================================
--- tmp/org.txm.index.rcp/src/org/txm/index/rcp/editors/PartitionIndexEditor.java	(revision 2947)
+++ tmp/org.txm.index.rcp/src/org/txm/index/rcp/editors/PartitionIndexEditor.java	(revision 2948)
@@ -220,7 +220,8 @@
 		propertiesSelector.setLayoutData(new GridData(GridData.FILL, GridData.FILL, false, false));
 		propertiesSelector.setLayout(new GridLayout(3, false));
 		try {
-			List<WordProperty> props = index.getCorpus().getOrderedProperties();
+			ArrayList<WordProperty> props = new ArrayList<>(index.getCorpus().getOrderedProperties());
+			props.addAll(index.getCorpus().getVirtualProperties());
 			propertiesSelector.setProperties(props);
 		}
 		catch (CqiClientException e) {
Index: tmp/org.txm.index.rcp/src/org/txm/index/rcp/editors/IndexEditor.java
===================================================================
--- tmp/org.txm.index.rcp/src/org/txm/index/rcp/editors/IndexEditor.java	(revision 2947)
+++ tmp/org.txm.index.rcp/src/org/txm/index/rcp/editors/IndexEditor.java	(revision 2948)
@@ -219,7 +219,8 @@
 		propertiesSelector.setLayoutData(new GridData(GridData.FILL, GridData.FILL, false, false));
 		propertiesSelector.setLayout(new GridLayout(3, false));
 		try {
-			List<WordProperty> props = index.getCorpus().getOrderedProperties();
+			ArrayList<WordProperty> props = new ArrayList<>(index.getCorpus().getOrderedProperties());
+			props.addAll(index.getCorpus().getVirtualProperties());
 			propertiesSelector.setProperties(props);
 		}
 		catch (CqiClientException e) {
Index: tmp/org.txm.cooccurrence.rcp/src/org/txm/cooccurrence/rcp/editors/CooccurrencesEditor.java
===================================================================
--- tmp/org.txm.cooccurrence.rcp/src/org/txm/cooccurrence/rcp/editors/CooccurrencesEditor.java	(revision 2947)
+++ tmp/org.txm.cooccurrence.rcp/src/org/txm/cooccurrence/rcp/editors/CooccurrencesEditor.java	(revision 2948)
@@ -612,6 +612,7 @@
 			List<WordProperty> available;
 			try {
 				available = new ArrayList<>(this.cooc.getCorpus().getProperties());
+				available.addAll(this.cooc.getCorpus().getVirtualProperties());
 				available.removeAll(cooc.getProperties());
 				this.propertiesSelector.setProperties(available, cooc.getProperties());
 			}
Index: tmp/org.txm.referencer.core/src/org/txm/referencer/core/functions/Referencer.java
===================================================================
--- tmp/org.txm.referencer.core/src/org/txm/referencer/core/functions/Referencer.java	(revision 2947)
+++ tmp/org.txm.referencer.core/src/org/txm/referencer/core/functions/Referencer.java	(revision 2948)
@@ -86,63 +86,60 @@
  * @author sjacquot
  */
 public class Referencer extends TXMResult {
-	
+
 	/** The noref. */
 	protected static int noref = 1;
-	
+
 	/** The prefix r. */
 	protected static String prefixR = "Referencer"; //$NON-NLS-1$
-	
+
 	/** The indexes. */
 	int[] indexes;
-	
+
 	/** The lines. */
 	List<Line> lines;
-	
+
 	/** The matches. */
 	List<Match> matches;
-	
+
 	/** The positions. */
 	int[] positions;
-	
+
 	/** The nlines. */
 	int nlines;
-	
+
 	/** The processed idx. */
 	HashMap<Integer, Line> processedIdx;
-	
+
 	/** The result. */
 	QueryResult result;
-	
+
 	/** The symbol. */
 	private String symbol;
-	
+
 	/** The writer. */
 	private BufferedWriter writer;
-	
-	
-	
-	
-	
+
+
+
+
+
 	/** The hierarchic sort. */
 	@Parameter(key = ReferencerPreferences.SORT_BY_FREQUENCIES)
 	protected boolean pHierarchicSort;
-	
+
 	@Parameter(key = ReferencerPreferences.PATTERN)
 	protected List<StructuralUnitProperty> pPattern;
-	
+
 	/** The prop. */
 	@Parameter(key = ReferencerPreferences.UNIT_PROPERTY)
-	protected Property pProperty;
-	
+	protected WordProperty pProperty;
+
 	/** The query. */
 	@Parameter(key = ReferencerPreferences.QUERY)
 	protected CQLQuery pQuery;
-	
-	
-	
-	
-	
+
+
 	/**
 	 * Creates a not computed referencer.
 	 *
@@ -151,8 +148,8 @@
 	public Referencer(CQPCorpus parent) {
 		super(parent);
 	}
-	
-	
+
+
 	/**
 	 * Creates a not computed referencer.
 	 * 
@@ -161,8 +158,8 @@
 	public Referencer(String parametersNodePath) {
 		super(parametersNodePath);
 	}
-	
-	
+
+
 	/**
 	 * As r matrix.
 	 *
@@ -170,14 +167,14 @@
 	 * @throws RWorkspaceException the r workspace exception
 	 */
 	public String asRMatrix() throws RWorkspaceException {
-		
+
 		String keywords[] = new String[lines.size()];
 		for (int i = 0; i < lines.size(); i++)
 			keywords[i] = lines.get(i).getPropValue();
 		// System.out.println(Arrays.toString(keywords));
-		
+
 		String symbol = prefixR + noref;
-		
+
 		RWorkspace rw = RWorkspace.getRWorkspaceInstance();
 		rw.eval(symbol + " <- list()"); //$NON-NLS-1$
 		rw.addVectorToWorkspace("refkeywords", keywords); //$NON-NLS-1$
@@ -192,12 +189,12 @@
 			rw.eval(symbol + "$refs[[" + i + "]] <- reflinerefs"); //$NON-NLS-1$ //$NON-NLS-2$
 			i++;
 		}
-		
+
 		noref++;
 		this.symbol = symbol;
 		return symbol;
 	}
-	
+
 	@Override
 	public void clean() {
 		try {
@@ -211,7 +208,7 @@
 			org.txm.utils.logger.Log.printStackTrace(e);
 		}
 	}
-	
+
 	/**
 	 * Clears all lines.
 	 */
@@ -220,7 +217,7 @@
 			line.clear();
 		}
 	}
-	
+
 	/**
 	 * Calls in order all stages to compute the referencer.
 	 *
@@ -232,11 +229,11 @@
 			if (!getQueryMatches()) {
 				return false;
 			}
-			
+
 			if (!getQueryindexes()) {
 				return false;
 			}
-			
+
 			if (!groupPositionsbyId()) {
 				return false;
 			}
@@ -245,10 +242,10 @@
 			e.printStackTrace();
 			return false;
 		}
-		
+
 		return true;
 	}
-	
+
 	/**
 	 * Gets the parent corpus.
 	 *
@@ -257,12 +254,12 @@
 	public CQPCorpus getCorpus() {
 		return (CQPCorpus) this.parent;
 	}
-	
+
 	@Override
 	public String getDetails() {
 		return getCorpus().getName();
 	}
-	
+
 	/**
 	 * Gets the lines.
 	 *
@@ -274,7 +271,7 @@
 	public List<Line> getLines() throws CqiClientException, IOException, CqiServerError {
 		return getLines(0, lines.size());
 	}
-	
+
 	/**
 	 * Gets the lines.
 	 *
@@ -292,16 +289,16 @@
 		if (to > lines.size()) {
 			to = lines.size();
 		}
-		
+
 		HashMap<Integer, Line> lineswithoutpropvalue = new HashMap<>();
-		
+
 		AbstractCqiClient cqiClient = CorpusManager.getCorpusManager().getCqiClient();
 		// build Missing lines
 		for (int i = from; i < to; i++) { // for each position group
 			Line l = lines.get(i);
 			if (l.notcomputed) {
 				lineswithoutpropvalue.put(l.id, l);
-				
+
 				// get all reference values of all position of the line
 				Map<Property, List<List<String>>> refValues = new HashMap<>();
 				for (Property property : pPattern) {
@@ -314,7 +311,7 @@
 					for (Property property : pPattern) {
 						propvalue += refValues.get(property).get(j).get(0) + ", "; //$NON-NLS-1$
 					}
-					
+
 					l.addReference(propvalue.substring(0, propvalue.length() - 2));
 				}
 				if (pHierarchicSort) {
@@ -326,22 +323,22 @@
 				l.notcomputed = false;
 			}
 		}
-		
+
 		// get idx String value
 		int[] idxwithoutvalues = new int[lineswithoutpropvalue.keySet().size()];
 		int count = 0;
 		for (int i : lineswithoutpropvalue.keySet()) {
 			idxwithoutvalues[count++] = i;
 		}
-		
-		String[] values = CorpusManager.getCorpusManager().getCqiClient().id2Str(pProperty.getQualifiedName(), idxwithoutvalues);
+
+		String[] values = pProperty.id2Str(idxwithoutvalues);
 		for (int i = 0; i < values.length; i++) {
 			int id = idxwithoutvalues[i];
 			lineswithoutpropvalue.get(id).linepropvalue = values[i];
 		}
 		return lines.subList(from, to);
 	}
-	
+
 	/**
 	 * Gets the name.
 	 *
@@ -356,8 +353,8 @@
 			return this.getEmptyName();
 		}
 	}
-	
-	
+
+
 	@Override
 	public String getSimpleName() {
 		if (this.pQuery != null && !this.pQuery.isEmpty()) {
@@ -367,14 +364,14 @@
 			return this.getEmptyName();
 		}
 	}
-	
-	
+
+
 	@Override
 	public String getComputingStartMessage() {
 		return TXMCoreMessages.bind(ReferencerCoreMessages.referencesOfP0InTheP1Corpus, this.pQuery.asString(), this.getCorpus().getName());
 	}
-	
-	
+
+
 	@Override
 	public String getComputingDoneMessage() {
 		if (this.lines == null || this.lines.isEmpty()) {
@@ -384,8 +381,8 @@
 			return TXMCoreMessages.bind(TXMCoreMessages.common_P0ItemsForP1Occurrences, TXMCoreMessages.formatNumber(this.getNLines()), TXMCoreMessages.formatNumber(this.getV()));
 		}
 	}
-	
-	
+
+
 	/**
 	 * Gets the n lines.
 	 *
@@ -394,7 +391,7 @@
 	public int getNLines() {
 		return nlines;
 	}
-	
+
 	/**
 	 * Gets the pattern.
 	 *
@@ -403,7 +400,7 @@
 	public List<StructuralUnitProperty> getPattern() {
 		return pPattern;
 	}
-	
+
 	/**
 	 * Gets the property.
 	 *
@@ -412,7 +409,7 @@
 	public Property getProperty() {
 		return pProperty;
 	}
-	
+
 	/**
 	 * Gets the query.
 	 *
@@ -421,7 +418,7 @@
 	public CQLQuery getQuery() {
 		return pQuery;
 	}
-	
+
 	/**
 	 * 2nd step.
 	 *
@@ -434,8 +431,8 @@
 			for (Match m : matches) {
 				positions[i++] = m.getStart();
 			}
-			
-			indexes = CorpusManager.getCorpusManager().getCqiClient().cpos2Id(pProperty.getQualifiedName(), positions);
+
+			indexes = pProperty.cpos2Id(positions);
 		}
 		catch (Exception e) {
 			// TODO Auto-generated catch block
@@ -444,7 +441,7 @@
 		}
 		return true;
 	}
-	
+
 	/**
 	 * 1st step.
 	 *
@@ -460,7 +457,7 @@
 		result.drop();
 		return true;
 	}
-	
+
 	/**
 	 * Gets the symbol.
 	 *
@@ -469,14 +466,14 @@
 	public String getSymbol() {
 		return symbol;
 	}
-	
+
 	public int getV() {
 		if (matches == null) {
 			return 0;
 		}
 		return matches.size();
 	}
-	
+
 	/**
 	 * 3rd stage.
 	 *
@@ -484,7 +481,7 @@
 	 */
 	public boolean groupPositionsbyId() {
 		processedIdx = new HashMap<>();
-		
+
 		lines = new ArrayList<>();
 		// System.out.println("indexes ");
 		for (int i = 0; i < indexes.length; i++) {
@@ -494,34 +491,34 @@
 				// System.out.println("add idx "+id);
 				Line l = new Line(id);
 				processedIdx.put(id, l);
-				
+
 				lines.add(l);
 			}
 			processedIdx.get(id).addPosition(positions[i]);
 		}
-		
+
 		nlines = processedIdx.keySet().size();
 		return true;
 	}
-	
-	public void setParameters(CQLQuery query, Property prop, List<StructuralUnitProperty> pattern, Boolean hierarchicSort) {
+
+	public void setParameters(CQLQuery query, WordProperty prop, List<StructuralUnitProperty> pattern, Boolean hierarchicSort) {
 		if (query != null) this.pQuery = query;
 		if (pattern != null) this.pPattern = pattern;
 		if (prop != null) this.pProperty = prop;
 		if (hierarchicSort != null) this.pHierarchicSort = hierarchicSort;
 		this.setDirty();
 	}
-	
+
 	@Override
 	public boolean setParameters(TXMParameters parameters) {
 		return false;
 	}
-	
+
 	@Deprecated
 	public boolean toTxt(File outfile, String encoding) throws Exception {
 		return toTxt(outfile, encoding, "\t", ""); //$NON-NLS-1$ //$NON-NLS-2$
 	}
-	
+
 	@Override
 	@Deprecated
 	public boolean _toTxt(File outfile, String encoding, String colseparator, String txtseparator) {
@@ -537,7 +534,7 @@
 		}
 		return true;
 	}
-	
+
 	@Deprecated
 	public void toTxt(Writer writer, int from, int to, String colseparator, String txtseparator)
 			throws CqiClientException, IOException {
@@ -549,7 +546,7 @@
 						.replace(txtseparator, txtseparator + txtseparator) + txtseparator + "\n"); //$NON-NLS-1$
 				writer.flush();
 			}
-			
+
 			writer.close();
 		}
 		catch (CqiServerError e) {
@@ -557,10 +554,10 @@
 			org.txm.utils.logger.Log.printStackTrace(e);
 		}
 	}
-	
+
 	@Override
 	public boolean canCompute() {
-		
+
 		if (pQuery == null || pQuery.isEmpty()) {
 			Log.fine("No query set.");
 			return false;
@@ -573,10 +570,10 @@
 			Log.fine("No property set.");
 			return false;
 		}
-		
+
 		return true;
 	}
-	
+
 	@Override
 	public boolean loadParameters() throws CqiClientException {
 		this.pQuery = new CQLQuery(this.getStringParameterValue(ReferencerPreferences.QUERY));
@@ -584,49 +581,49 @@
 		this.pProperty = this.getCorpus().getProperty(this.getStringParameterValue(ReferencerPreferences.UNIT_PROPERTY));
 		return true;
 	}
-	
+
 	@Override
 	public boolean saveParameters() {
 		if (this.pQuery != null) {
 			this.saveParameter(ReferencerPreferences.QUERY, this.pQuery.getQueryString());
 		}
-		
+
 		if (this.pPattern != null) {
 			this.saveParameter(ReferencerPreferences.PATTERN, StructuralUnitProperty.propertiesToString(this.pPattern));
 		}
-		
+
 		if (this.pProperty != null) {
 			this.saveParameter(ReferencerPreferences.UNIT_PROPERTY, this.pProperty.getName());
 		}
 		return true;
 	}
-	
-	
-	
-	
+
+
+
+
 	/**
 	 * The Class Line.
 	 */
 	public class Line {
-		
+
 		/** The id. */
 		int id;
-		
+
 		/** The propvalue. */
 		String linepropvalue;
-		
+
 		/** The notcomputed. */
 		boolean notcomputed = true;
-		
+
 		/** The positions. */
 		ArrayList<Integer> positions;
-		
+
 		/** The references. */
 		ArrayList<String> references;
-		
+
 		/** The references counts. */
 		HashMap<String, Integer> referencesCounts = new HashMap<>();
-		
+
 		/**
 		 * Instantiates a new line.
 		 *
@@ -637,7 +634,7 @@
 			positions = new ArrayList<>();
 			references = new ArrayList<>();
 		}
-		
+
 		/**
 		 * Adds the position.
 		 *
@@ -646,7 +643,7 @@
 		public void addPosition(int i) {
 			positions.add(i);
 		}
-		
+
 		/**
 		 * Adds the reference.
 		 *
@@ -661,7 +658,7 @@
 				referencesCounts.put(string, referencesCounts.get(string) + 1);
 			}
 		}
-		
+
 		/**
 		 * Clear.
 		 */
@@ -669,7 +666,7 @@
 			notcomputed = false;
 			references = new ArrayList<>();
 		}
-		
+
 		/**
 		 * Gets the count.
 		 *
@@ -679,11 +676,11 @@
 		public int getCount(String ref) {
 			return referencesCounts.get(ref);
 		}
-		
+
 		public HashMap<String, Integer> getCounts() {
 			return referencesCounts;
 		}
-		
+
 		/**
 		 * Gets the prop value.
 		 *
@@ -692,7 +689,7 @@
 		public String getPropValue() {
 			return linepropvalue;
 		}
-		
+
 		/**
 		 * Gets the references.
 		 *
@@ -701,14 +698,14 @@
 		public List<String> getReferences() {
 			return references;
 		}
-		
+
 		/**
 		 * Sort alpha.
 		 */
 		public void sortAlpha() {
 			Collections.sort(references);
 		}
-		
+
 		/**
 		 * Sort ref.
 		 *
@@ -716,7 +713,7 @@
 		 */
 		public void sortRef(final boolean reverse) {
 			Collections.sort(references, new Comparator<String>() {
-				
+
 				@Override
 				public int compare(String arg0, String arg1) {
 					if (reverse)
@@ -726,7 +723,7 @@
 				}
 			});
 		}
-		
+
 		/*
 		 * (non-Javadoc)
 		 * @see java.lang.Object#toString()
@@ -736,20 +733,20 @@
 			return linepropvalue + " : <" + id + "," + pProperty + "> : " + references.toString(); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
 		}
 	}
-	
+
 	public void setQuery(CQLQuery query) {
 		this.pQuery = query;
 	}
-	
-	public void setProperty(Property property) {
+
+	public void setProperty(WordProperty property) {
 		this.pProperty = property;
 	}
-	
+
 	public void setPattern(List<StructuralUnitProperty> properties) {
 		this.pPattern = properties;
 	}
-	
-	
+
+
 	/**
 	 * Creates a CQL query string from the specified Referencer lines.
 	 *
@@ -757,32 +754,30 @@
 	 * @return the query
 	 */
 	public String createQuery(List<Line> lines) {
-		String query = ""; //$NON-NLS-1$
-		
-		int nbToken = 1;
-		
-		
+
 		Property prop = this.getProperty();
-		for (int t = 0; t < nbToken; t++) {
-			query += "[" + prop + "=\""; //$NON-NLS-1$ //$NON-NLS-2$
-			
-			for (Line line : lines) {
-				String s = line.getPropValue();
-				s = CQLQuery.addBackSlash(s);
-				query += s + "|"; //$NON-NLS-1$
-			}
-			query = query.substring(0, query.length() - 1);
-			query += "\"] "; //$NON-NLS-1$
+		String query = "["; //$NON-NLS-1$
+
+		ArrayList<String> values = new ArrayList<>();
+		for (Line line : lines) {
+			String s = line.getPropValue();
+			values.add(s);
 		}
-		query = query.substring(0, query.length() - 1);
-		return query;
+		String test = ((WordProperty) prop).getCQLTest(values);
+		if (test != null) {
+			query += test;
+		}
 		
+		query += "]"; //$NON-NLS-1$
+				
+		return query;
+
 	}
-	
+
 	@Override
 	public String getResultType() {
 		return ReferencerCoreMessages.RESULT_TYPE;
 	}
-	
-	
+
+
 }
Index: tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/editors/ConcordanceEditor.java
===================================================================
--- tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/editors/ConcordanceEditor.java	(revision 2947)
+++ tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/editors/ConcordanceEditor.java	(revision 2948)
@@ -1072,6 +1072,8 @@
 		propertiesPanel.getLayout().numColumns = 5;
 		propertiesPanel.getLayout().makeColumnsEqualWidth = false;
 		
+		ArrayList<WordProperty> tmp; // tmp to store properties
+		
 		try {
 			Label l = new Label(propertiesPanel, SWT.NONE);
 			l.setText(ConcordanceUIMessages.editor_21);
@@ -1109,7 +1111,9 @@
 			leftViewProperties = new PropertiesSelector<>(propertiesPanel, SWT.NONE);
 			leftViewProperties.setLayoutData(new GridData(GridData.CENTER, GridData.CENTER, false, false));
 			leftViewProperties.setTitle(ConcordanceUIMessages.editor_21);
-			leftViewProperties.setProperties(getCorpus().getOrderedProperties());
+			tmp = new ArrayList<>(getCorpus().getOrderedProperties());
+			tmp.addAll(getCorpus().getVirtualProperties());
+			leftViewProperties.setProperties(tmp);
 			leftViewProperties.setButtonText(ConcordanceUIMessages.editor_19);
 			leftViewProperties.addSelectionListener(new ComputeSelectionListener(this) {
 				
@@ -1123,7 +1127,9 @@
 			keywordViewProperties = new PropertiesSelector<>(propertiesPanel, SWT.NONE);
 			keywordViewProperties.setLayoutData(new GridData(GridData.CENTER, GridData.CENTER, false, false));
 			keywordViewProperties.setTitle(ConcordanceUIMessages.editor_21);
-			keywordViewProperties.setProperties(getCorpus().getOrderedProperties());
+			tmp = new ArrayList<>(getCorpus().getOrderedProperties());
+			tmp.addAll(getCorpus().getVirtualProperties());
+			keywordViewProperties.setProperties(tmp);
 			keywordViewProperties.setButtonText(ConcordanceUIMessages.editor_19);
 			keywordViewProperties.addSelectionListener(new ComputeSelectionListener(this) {
 				
@@ -1137,7 +1143,9 @@
 			rightViewProperties = new PropertiesSelector<>(propertiesPanel, SWT.NONE);
 			rightViewProperties.setLayoutData(new GridData(GridData.CENTER, GridData.CENTER, false, false));
 			rightViewProperties.setTitle(ConcordanceUIMessages.editor_21);
-			rightViewProperties.setProperties(getCorpus().getOrderedProperties());
+			tmp = new ArrayList<>(getCorpus().getOrderedProperties());
+			tmp.addAll(getCorpus().getVirtualProperties());
+			rightViewProperties.setProperties(tmp);
 			rightViewProperties.setButtonText(ConcordanceUIMessages.editor_19);
 			rightViewProperties.addSelectionListener(new ComputeSelectionListener(this) {
 				
@@ -1170,7 +1178,9 @@
 			leftSortProperties.setLayoutData(new GridData(GridData.CENTER, GridData.CENTER, false, false));
 			leftSortProperties.setTitle(ConcordanceUIMessages.editor_21);
 			leftSortProperties.setButtonText(ConcordanceUIMessages.editor_19);
-			leftSortProperties.setProperties(getCorpus().getOrderedProperties());
+			tmp = new ArrayList<>(getCorpus().getOrderedProperties());
+			tmp.addAll(getCorpus().getVirtualProperties());
+			leftSortProperties.setProperties(tmp);
 			leftSortProperties.addSelectionListener(new ComputeSelectionListener(this) {
 				
 				@Override
@@ -1184,7 +1194,9 @@
 			keywordSortProperties.setLayoutData(new GridData(GridData.CENTER, GridData.CENTER, false, false));
 			keywordSortProperties.setTitle(ConcordanceUIMessages.editor_21);
 			keywordSortProperties.setButtonText(ConcordanceUIMessages.editor_19);
-			keywordSortProperties.setProperties(getCorpus().getOrderedProperties());
+			tmp = new ArrayList<>(getCorpus().getOrderedProperties());
+			tmp.addAll(getCorpus().getVirtualProperties());
+			keywordSortProperties.setProperties(tmp);
 			keywordSortProperties.addSelectionListener(new ComputeSelectionListener(this) {
 				
 				@Override
@@ -1198,7 +1210,9 @@
 			rightSortProperties.setLayoutData(new GridData(GridData.CENTER, GridData.CENTER, false, false));
 			rightSortProperties.setTitle(ConcordanceUIMessages.editor_21);
 			rightSortProperties.setButtonText(ConcordanceUIMessages.editor_19);
-			rightSortProperties.setProperties(getCorpus().getOrderedProperties());
+			tmp = new ArrayList<>(getCorpus().getOrderedProperties());
+			tmp.addAll(getCorpus().getVirtualProperties());
+			rightSortProperties.setProperties(tmp);
 			rightSortProperties.addSelectionListener(new ComputeSelectionListener(this) {
 				
 				@Override
Index: tmp/org.txm.lexicaltable.rcp/src/org/txm/lexicaltable/rcp/editors/LexicalTableEditor.java
===================================================================
--- tmp/org.txm.lexicaltable.rcp/src/org/txm/lexicaltable/rcp/editors/LexicalTableEditor.java	(revision 2947)
+++ tmp/org.txm.lexicaltable.rcp/src/org/txm/lexicaltable/rcp/editors/LexicalTableEditor.java	(revision 2948)
@@ -66,6 +66,7 @@
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
 import org.txm.searchengine.cqp.corpus.CQPCorpus;
 import org.txm.searchengine.cqp.corpus.MainCorpus;
+import org.txm.searchengine.cqp.corpus.WordProperty;
 import org.txm.statsengine.core.StatException;
 import org.txm.statsengine.core.data.Vector;
 import org.txm.statsengine.r.rcp.views.RVariablesView;
@@ -177,11 +178,14 @@
 			
 			// unit property
 			new Label(mainParametersArea, SWT.NONE).setText(TXMCoreMessages.common_property);
+			ArrayList<WordProperty> availablesProperties = new ArrayList<>();
+			availablesProperties.addAll(CQPCorpus.getFirstParentCorpus(this.getResult()).getOrderedProperties());
+			availablesProperties.addAll(CQPCorpus.getFirstParentCorpus(this.getResult()).getVirtualProperties());
 			this.unitPropertyComboViewer = new PropertiesComboViewer(
 					mainParametersArea,
 					this,
 					false,
-					CQPCorpus.getFirstParentCorpus(this.getResult()).getOrderedProperties(),
+					availablesProperties,
 					this.getResult().getProperty(),
 					false);
 			
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/views/cmdparameters/ParametersView.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/views/cmdparameters/ParametersView.java	(revision 2947)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/views/cmdparameters/ParametersView.java	(revision 2948)
@@ -507,8 +507,11 @@
 		
 		WordProperty value = selected.get(0);
 		CQPCorpus corpus = ((WordProperty) value).getCorpus();
-		List<WordProperty> availables = corpus.getOrderedProperties();
+		
+		ArrayList<WordProperty> availables = new ArrayList<>(corpus.getOrderedProperties());
+		availables.addAll(corpus.getVirtualProperties());
 		availables.remove(value);
+		
 		PropertiesSelector<WordProperty> selector = new PropertiesSelector<WordProperty>(panel, SWT.NONE);
 		selector.setProperties(availables, selected);
 		selector.addSelectionListener(new SelectionListener() {
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/dialog/SinglePropertySelectionDialog.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/dialog/SinglePropertySelectionDialog.java	(revision 2947)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/dialog/SinglePropertySelectionDialog.java	(revision 2948)
@@ -197,13 +197,9 @@
 		availablePropertiesView.removeAll();
 		for (Property property : allProperties) {
 			// if (!property.getName().equals("id")) //$NON-NLS-1$
-			if (property instanceof VirtualProperty) {
-				availablePropertiesView.add(((VirtualProperty) property).getFullName());
-			}
-			else if (property instanceof StructuralUnitProperty) {
-				availablePropertiesView.add(((StructuralUnitProperty) property).getFullName());
-			}
-			else {
+			if (property instanceof StructuralUnitProperty || property instanceof VirtualProperty) {
+				availablePropertiesView.add(property.getFullName());
+			} else {
 				availablePropertiesView.add(property.getName());
 			}
 		}
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/dialog/MultiplePropertySelectionDialog.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/dialog/MultiplePropertySelectionDialog.java	(revision 2947)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/dialog/MultiplePropertySelectionDialog.java	(revision 2948)
@@ -311,12 +311,9 @@
 		availablePropertiesView.removeAll();
 		for (Property property : availableProperties) {
 			// if (!property.getName().equals("id")) //$NON-NLS-1$
-			if (property instanceof VirtualProperty) {
-				availablePropertiesView.add(((VirtualProperty) property).getFullName());
+			if (property instanceof StructuralUnitProperty || property instanceof VirtualProperty) {
+				availablePropertiesView.add(property.getFullName());
 			}
-			else if (property instanceof StructuralUnitProperty) {
-				availablePropertiesView.add(((StructuralUnitProperty) property).getFullName());
-			}
 			else {
 				availablePropertiesView.add(property.getName());
 			}
@@ -324,8 +321,8 @@
 		selectedPropertiesView.removeAll();
 		for (Property property : selectedProperties) {
 			// if (!property.getName().equals("id")) //$NON-NLS-1$
-			if (property instanceof StructuralUnitProperty) {
-				selectedPropertiesView.add(((StructuralUnitProperty) property).getFullName());
+			if (property instanceof StructuralUnitProperty || property instanceof VirtualProperty) {
+				selectedPropertiesView.add(property.getFullName());
 			}
 			else {
 				selectedPropertiesView.add(property.getName());
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/structures/PropertiesComboViewer.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/structures/PropertiesComboViewer.java	(revision 2947)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/structures/PropertiesComboViewer.java	(revision 2948)
@@ -7,13 +7,18 @@
 
 import org.eclipse.jface.viewers.ArrayContentProvider;
 import org.eclipse.jface.viewers.ComboViewer;
+import org.eclipse.jface.viewers.IBaseLabelProvider;
+import org.eclipse.jface.viewers.ILabelProviderListener;
 import org.eclipse.jface.viewers.StructuredSelection;
 import org.eclipse.swt.SWT;
 import org.eclipse.swt.widgets.Composite;
 import org.txm.core.results.TXMResult;
 import org.txm.rcp.editors.TXMEditor;
 import org.txm.rcp.editors.listeners.ComputeSelectionListener;
+import org.txm.rcp.swt.provider.SimpleLabelProvider;
 import org.txm.searchengine.cqp.corpus.Property;
+import org.txm.searchengine.cqp.corpus.StructuralUnitProperty;
+import org.txm.searchengine.cqp.corpus.VirtualProperty;
 
 /**
  * Combo viewer for token/word properties of a corpus with only single selection support.
@@ -44,7 +49,7 @@
 		this.addBlankEntry = addBlankEntry;
 		
 		this.setContentProvider(ArrayContentProvider.getInstance());
-
+		
 		this.updateFromList(properties, selectedProperty);
 		
 		// Listener
